
import java.lang.*;
import java.io.*;

public class KrTrace
{
  // Variables
  static private PrintWriter out = null;
  static private int initialized = 0;
  
  // Methods
  
  static public synchronized void start()
  {
    if(initialized == 0) {
      out = null;
      initialized = 1;
    }
  }
  
  static public synchronized void start(String name)
  {
    File f = null;
    
    if(initialized == 0) {
      try {
        File outputFile = new File(name);
        out = new PrintWriter(new FileOutputStream(outputFile));
        initialized = 1;
      }
      /*
      catch (FileNotFoundException e) {
        System.err.println("KrTrace: FileNotFoundException in start");
        initialized = 0;
      }
      */
      catch (IOException e) {
        System.err.println("KrTrace: IOException in start");
        initialized = 0;
      }
    }
  }
  
  static public synchronized void stop()
  {
    if(initialized == 1) {
      if(out != null) {
        out.close();
        out = null;
        initialized = 0;
      }
    }
  }
  
  static public synchronized 
  void printMessage(String msg)
  {
    if(initialized == 1) {
      if(out != null) {
        out.println(msg);
      } else {
        System.out.println(msg);
      }
    }
  }
  
}


