#! /bin/sh
rm -fr jar
mkdir jar


# ##### Uncomment this section if you have fig2vect, pdflatex and Xpdf #####
# ##### available                                                      #####
# cd splash
# fig2vect -lpdf.tex splash.fig splash-i.pdf
# fig2vect -ltex.full splash.fig splash.tex -i splash-i.pdf
# pdflatex splash
# pdftoppm splash.pdf sp
# pnmtopng sp-1.ppm > splash.png
# cd ..

JAVA=`which java`
JAVADIR=`echo $JAVA | sed -e 's/\/bin\/java//g'`
JAVADIR=`echo $JAVADIR | sed -e 's/\/jre$//g'`
JNLP=`find $JAVADIR -name 'jnlp.jar'`
# Compile sources
cd src
for i in traceccgui/*.java
do
echo javac -cp . -d ../jar $i
javac -cp . -d ../jar $i
done
cd ..

# Add resources
(cd res; tar cf - .) | (cd jar; tar xf -)
(cd loc; tar cf - .) | (cd jar; tar xf -)
(cd jar.in; tar cf - .) | (cd jar; tar xf -)
cp splash/splash.png jar

# rm -fr jar/de

# Package jar file
cd jar
cp ChooseDirectory.png traceccgui
cp Options.png traceccgui
cp Run.png traceccgui
cp Exit.png traceccgui
jar -cvfm ../tracegui.jar manifest.in *
cd ..

# Copy jar file
cp tracegui.jar ..

rm -fr doc/dklibsj
mkdir -p doc/dklibsj
rm -fr dklibsj
mkdir dklibsj
cd src
for i in dirk_krause/tools/*.java
do
  javac -cp . -d ../dklibsj $i
done
javadoc -classpath . -d ../doc/dklibsj -doctitle 'DK libraries for Java' dirk_krause/tools/*.java
cd ..
cd dklibsj
jar cvf ../dklibsj.jar dirk_krause
cd ..
cp dklibsj.jar ..

rm -fr doc/wdklibsj
mkdir -p doc/wdklibsj
rm -fr wdklibsj
mkdir wdklibsj
cd src
for i in dirk_krause/wstools/*.java
do
  javac -cp .:$JNLP -d ../wdklibsj $i
done
javadoc -classpath .:$JNLP -d ../doc/wdklibsj -doctitle 'DK libraries for Java webstart' dirk_krause/wstools/*.java
cd ..
cd wdklibsj
jar cvf ../wdklibsj.jar dirk_krause
cd ..
cp wdklibsj.jar ..

