/**
<p>The DK libraries for Java contain the following classes:</p>
<ul>
<li><b>DkTool</b><br>
This class is a multi-purpose tool for
<ul>
<li>Information retrieval<br>
user name, users language, users region, users home directory, current
directory, host name, file separator and path separator.<br>
<i>Note:</i> Most of this information is not available for untrusted
web-start applications or applets.<br>
If you want to use this information make your application trusted
by adding
<pre>
&lt;security&gt;
&lt;all-permissions/&gt;
&lt;/security&gt;
</pre>
and
<pre>
&lt;property name="user.language" value="..."&gt;
&lt;property name="user.country" value="..."&gt;
</pre>
to the *.jnlp file. Do not forget to sign all the *.jar files involved.
</li>
<li>String processing<br>
Retrieve the index of a string in a string array, convert strings to booleans,
numbers, and colors. You can also trim strings, encode strings for use in
HTML or PostScript documents, change a file name suffix and convert a
string containing a date to a normalized date in german notation.
</li>
<li>Preferences management<br>
Save and retrieve strings, integers and booleans, bulk get and set.
</li>
<li>Resource search<br>
Specify resource base locations (http://, file:// or without prefix to search
in the *.jar file), return resources as InputStream, String or String array.<br>
Resource search includes font and image (BufferedImage, ImageIcon) search.
</li>
<li>Localization<br>
Search for resources in <i>ll</i>/<i>rr</i> and <i>ll</i> subdirectories
of resources bases (<i>ll</i> is the 2-letter language code, <i>rr</i>
is the 2-letter country code) for localized resources.<br>
This feature requires access to the "user.language" and "user.country"
system properties.
</li>
<li>Positioning of GUI elements<br>
Choose a good position for modal and nonmodal dialog boxes relative
to the parent frame.
</li>
</ul>
</li>
<li><b>DkGuiTool</b><br>
The DkGuiTool is used for GUI-related settings. It uses a DkTool object
to retrieve settings from preferences.<br>
The constructor of the first DkGuiTool object sets up the look-and-feel,
and changes fonts (i.e. enforces a minimum font size and optionally
replaces all fonts from one family by another family).
</li>
<li><b>DkFrame</b><br>
An extended JFrame saving the position and size if the last frame of it's kind
is closed. A method choosePosition() can be used after constructing and packing
the first frame in a program to restore position and size.<br>
Additionally there are convenience functions to show message
dialog boxes and to send PostScript data or a Printable object to a printer.<br>
The protected elements dkt, dkgt and border  (DkTool, DkGuiTool and int: space
between components) are available to derived classes.
</li>
<li><b>DkDialog</b><br>
An extended dialog making dkt, dkgt and border (constructor arguments)
available to derived classes.
</li>
<li><b>DkGuiDialog</b><br>
Dialog box to set up the GUI, shown from DkFrame's showGuiDialog() method.
</li>
<li><b>DkMsgDialog</b><br>
Dialog box to show a message, used from DkFrame's methods to show message
dialog boxes if JOptionPane fails.
</li>
<li><b>DkColorArea</b><br>
A square showing a color value. A cklick on the square opens the color
chooser dialog box.
</li>
<li><b>DkLogPanel</b><br>
A panel to write log messages to.
</li>
<li><b>DkDropFile</b><br>
A drop transfer handler.
</li>
<li><b>DkDropOneDirectory</b><br>
A drop transfer handler accepting exactly one directory name.
</li>
<li><b>DkSizeTracker</b><br>
If you change a GUI components contents (i.e. the text in a label)
you sometimes need to increase the size. The size tracker can be used
to find whether or not a call to pack() is necessary.
</li>
<li><b>DkPrintClient</b><br>
Object to connect to print services. This class is not intended for
direct use, it is used internally by the DkFrame class.
</li>
<li><b>DkPrintResult</b><br>
Result of a print operation. This class is not intended for direct use,
it is used internally by the DkFrame class.
</li>
</ul>
<p>For more information see
<a href="http://dklibs.sourceforge.net/dklibsj.html">DK libraries for Java</a>
*/
package dirk_krause.tools;

