
package dirk_krause.wstools;

import javax.swing.JDialog;
import javax.swing.JFrame;



/**
 * Dialog base class.
 * This class saves the references provided to the constructor
 * for later use and provides the references to subclasses.
 * @author krause
 */
class DkDialog extends JDialog
{

    /** General options tool. */
    protected DkTool dkt = null;

    /** GUI options tool. */
    protected DkGuiTool dkgt = null;

    /** Border (space) between GUI elements. */
    protected int border = 5;

    /** Parent frame. */
    protected JFrame parentFrame = null;

    /**
     * Constructor.
     * @param p Parent frame.
     * @param d General tool.
     * @param g GUI tool.
     * @param t Used for preferences in later versions.
     */
    public DkDialog(JFrame p, DkTool d, DkGuiTool g, String t)
    {
        super(p);
	dkt = d; dkgt = g; parentFrame = p;
	border = dkgt.getComponentBorder();
    }


}

