/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dirk_krause.wstools;

/**
 * Objects of this class are returned by DkPrintclient objects after
 * finishing a print job.
 * @author krause
 */
public class DkPrintResult {
    /** Result of the print job. */
    protected boolean res = false;

    /** Title to show in the result dialog box. */
    protected String title = null;

    /** Text to show in the result dialog box. */
    protected String message = null;

    /**
     * Constructor.
     * @param r Flag: Success or not.
     * @param t Title for dialog box to show.
     * @param m Text for dialog box to show.
     */
    public DkPrintResult(boolean r, String t, String m) {
        res = r; title = t; message = m;
    }

    /**
     * Retrieve success flag.
     * @return  Flag to indicate success.
     */
    public boolean getResult() {
        return res;
    }


    /**
     * Retrieve dialog box title.
     * @return  General description of success or error.
     */
    public String getTitle() {
        return title;
    }


    /**
     * Retrieve dialog box text.
     * @return  Detailed description of print job result.
     */
    public String getText() {
        return message;
    }
}
