/*
Copyright (c) 2010, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/


package traceccgui;

// jlayout.import.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.awt.event.ItemListener;
import javax.swing.JComponent;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.WindowConstants;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.import.end

import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.ItemEvent;

import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.awt.event.ItemListener;

import javax.swing.JFrame;
import javax.swing.JDialog;

import dirk_krause.tools.*;


/**
 *
 * @author krause
 */
public class TraceccOptions
        extends JDialog
        implements ActionListener, WindowListener, ItemListener
{
    /** Border (space between components). */
    private int b = 5;

    /** Application controller. */
    private DkTool dkt = null;

    /** Controller for tracecc options. */
    private TraceccController tc = null;

    /** Texts used by the GUI. */
    private String[] t = null;

    /** Flag: Currently doing corrections. */
    private boolean in_correction = false;

    /** IDE types, used in constructor of cbIdeType. */
    private String[] ideTypes = null;


// jlayout.variables.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private int jLayoutSizeMinX = 0;
	private int jLayoutSizeMinY = 0;
	private int jLayoutSizePrefX = 0;
	private int jLayoutSizePrefY = 0;
	private int jLayoutSizeMaxX = 0;
	private int jLayoutSizeMaxY = 0;
	JButton bCancel = null;
	JButton bDefaults = null;
	JButton bOK = null;
	JButton bReload = null;
	JCheckBox cbC = null;
	JCheckBox cbCpp = null;
	JCheckBox cbCppComments = null;
	JCheckBox cbDebug = null;
	JCheckBox cbDebugIDE = null;
	JCheckBox cbDebugStdout = null;
	JCheckBox cbDebugTime = null;
	JCheckBox cbDebugTrace = null;
	JComboBox cbIdeType = null;
	JCheckBox cbJl = null;
	JCheckBox cbJtr = null;
	JCheckBox cbLine = null;
	JCheckBox cbM = null;
	JCheckBox cbMake = null;
	JLabel lCommentBoxWidth = null;
	JLabel lDummyDebug = null;
	JPanel pButtons = null;
	JPanel pDebug = null;
	JPanel pGeneral = null;
	JPanel pInput = null;
	JPanel pOptions = null;
	JPanel pOutput = null;
	JPanel pa = null;
	JTextField tfCommentBoxWidth = null;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.variables.end
// jlayout.setup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Reset the stored size informatio.
	 */
	private void jLayoutResetSizes()
	{
	  jLayoutSizeMinX = 0; jLayoutSizeMinY = 0;
	  jLayoutSizeMaxX = 0; jLayoutSizeMaxY = 0;
	  jLayoutSizePrefX = 0; jLayoutSizePrefY = 0;
	}
	private void jLayoutGetSize(JComponent c)
	{
	  Dimension d;
	  d = c.getMinimumSize();
	  if(d.width > jLayoutSizeMinX) { jLayoutSizeMinX = d.width; }
	  if(d.height > jLayoutSizeMinY) { jLayoutSizeMinY = d.height; }
	  d = c.getPreferredSize();
	  if(d.width > jLayoutSizePrefX) { jLayoutSizePrefX = d.width; }
	  if(d.height > jLayoutSizePrefY) { jLayoutSizePrefY = d.height; }
	  d = c.getMaximumSize();
	  if(d.width > jLayoutSizeMaxX) { jLayoutSizeMaxX = d.width; }
	  if(d.height > jLayoutSizeMaxY) { jLayoutSizeMaxY = d.height; }
	}
	/**
	 * Set a components size to a given minimum (save as other
	 * components).
	 *
	 * @param c
	 * The component to change.
	 */
	private void jLayoutSetSize(JComponent c)
	{
	  c.setMinimumSize(new Dimension(jLayoutSizeMinX, jLayoutSizeMinY));
	  c.setPreferredSize(new Dimension(jLayoutSizePrefX, jLayoutSizePrefY));
	  c.setMaximumSize(new Dimension(jLayoutSizeMaxX, jLayoutSizeMaxY));
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bCancel 142
	  bCancel = new JButton(t[28]);
	  bCancel.setToolTipText(t[32]);
	  bCancel.getAccessibleContext().setAccessibleDescription(
	    t[32]
	  );
	  // bDefaults 146
	  bDefaults = new JButton(t[30]);
	  bDefaults.setToolTipText(t[34]);
	  bDefaults.getAccessibleContext().setAccessibleDescription(
	    t[34]
	  );
	  // bOK 140
	  bOK = new JButton(t[27]);
	  bOK.setToolTipText(t[31]);
	  bOK.getAccessibleContext().setAccessibleDescription(
	    t[31]
	  );
	  // bReload 144
	  bReload = new JButton(t[29]);
	  bReload.setToolTipText(t[33]);
	  bReload.getAccessibleContext().setAccessibleDescription(
	    t[33]
	  );
	  // cbC 70
	  cbC = new JCheckBox(t[46]);
	  cbC.setToolTipText(t[47]);
	  cbC.getAccessibleContext().setAccessibleDescription(
	    t[47]
	  );
	  // cbCpp 71
	  cbCpp = new JCheckBox(t[48]);
	  cbCpp.setToolTipText(t[49]);
	  cbCpp.getAccessibleContext().setAccessibleDescription(
	    t[49]
	  );
	  // cbCppComments 45
	  cbCppComments = new JCheckBox(t[41]);
	  cbCppComments.setToolTipText(t[42]);
	  cbCppComments.getAccessibleContext().setAccessibleDescription(
	    t[42]
	  );
	  // cbDebug 101
	  cbDebug = new JCheckBox(t[57]);
	  cbDebug.setToolTipText(t[58]);
	  cbDebug.getAccessibleContext().setAccessibleDescription(
	    t[58]
	  );
	  // cbDebugIDE 104
	  cbDebugIDE = new JCheckBox(t[61]);
	  cbDebugIDE.setToolTipText(t[62]);
	  cbDebugIDE.getAccessibleContext().setAccessibleDescription(
	    t[62]
	  );
	  // cbDebugStdout 103
	  cbDebugStdout = new JCheckBox(t[59]);
	  cbDebugStdout.setToolTipText(t[60]);
	  cbDebugStdout.getAccessibleContext().setAccessibleDescription(
	    t[60]
	  );
	  // cbDebugTime 106
	  cbDebugTime = new JCheckBox(t[63]);
	  cbDebugTime.setToolTipText(t[64]);
	  cbDebugTime.getAccessibleContext().setAccessibleDescription(
	    t[64]
	  );
	  // cbDebugTrace 107
	  cbDebugTrace = new JCheckBox(t[65]);
	  cbDebugTrace.setToolTipText(t[66]);
	  cbDebugTrace.getAccessibleContext().setAccessibleDescription(
	    t[66]
	  );
	  // cbIdeType 105
	  cbIdeType = new JComboBox(ideTypes);
	  // cbJl 74
	  cbJl = new JCheckBox(t[54]);
	  cbJl.setToolTipText(t[55]);
	  cbJl.getAccessibleContext().setAccessibleDescription(
	    t[55]
	  );
	  // cbJtr 73
	  cbJtr = new JCheckBox(t[52]);
	  cbJtr.setToolTipText(t[53]);
	  cbJtr.getAccessibleContext().setAccessibleDescription(
	    t[53]
	  );
	  // cbLine 44
	  cbLine = new JCheckBox(t[39]);
	  cbLine.setToolTipText(t[40]);
	  cbLine.getAccessibleContext().setAccessibleDescription(
	    t[40]
	  );
	  // cbM 72
	  cbM = new JCheckBox(t[50]);
	  cbM.setToolTipText(t[51]);
	  cbM.getAccessibleContext().setAccessibleDescription(
	    t[51]
	  );
	  // cbMake 32
	  cbMake = new JCheckBox(t[36]);
	  cbMake.setToolTipText(t[37]);
	  cbMake.getAccessibleContext().setAccessibleDescription(
	    t[37]
	  );
	  // lCommentBoxWidth 46
	  lCommentBoxWidth = new JLabel(t[43]);
	  // lDummyDebug 102
	  lDummyDebug = new JLabel(t[67]);
	  // pButtons 18
	  pButtons = new JPanel();
	  {
	    pButtons.setLayout(new BoxLayout(pButtons, BoxLayout.LINE_AXIS));
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bOK);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bCancel);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bReload);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bDefaults);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	  }
	  // pDebug 25
	  pDebug = new JPanel();
	  pDebug.setBorder(
	    BorderFactory.createTitledBorder(t[56])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pDebug.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      7, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      7, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebug.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 6, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebug, gbc);
	    pDebug.add(cbDebug);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lDummyDebug, gbc);
	    pDebug.add(lDummyDebug);
	    gbc = jLayoutGbc(
	      3, 3, 4, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugStdout, gbc);
	    pDebug.add(cbDebugStdout);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugIDE, gbc);
	    pDebug.add(cbDebugIDE);
	    gbc = jLayoutGbc(
	      5, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbIdeType, gbc);
	    pDebug.add(cbIdeType);
	    gbc = jLayoutGbc(
	      3, 7, 4, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugTime, gbc);
	    pDebug.add(cbDebugTime);
	    gbc = jLayoutGbc(
	      3, 9, 4, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugTrace, gbc);
	    pDebug.add(cbDebugTrace);
	  }
	  // pGeneral 22
	  pGeneral = new JPanel();
	  pGeneral.setBorder(
	    BorderFactory.createTitledBorder(t[35])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pGeneral.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneral.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneral.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbMake, gbc);
	    pGeneral.add(cbMake);
	  }
	  // pInput 24
	  pInput = new JPanel();
	  pInput.setBorder(
	    BorderFactory.createTitledBorder(t[45])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pInput.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pInput.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbC, gbc);
	    pInput.add(cbC);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbCpp, gbc);
	    pInput.add(cbCpp);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbM, gbc);
	    pInput.add(cbM);
	    gbc = jLayoutGbc(
	      1, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbJtr, gbc);
	    pInput.add(cbJtr);
	    gbc = jLayoutGbc(
	      1, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbJl, gbc);
	    pInput.add(cbJl);
	  }
	  // tfCommentBoxWidth 47
	  tfCommentBoxWidth = new JTextField(4);
	  tfCommentBoxWidth.setToolTipText(t[44]);
	  tfCommentBoxWidth.getAccessibleContext().setAccessibleDescription(
	    t[44]
	  );
	  // pOutput 23
	  pOutput = new JPanel();
	  pOutput.setBorder(
	    BorderFactory.createTitledBorder(t[38])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pOutput.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      4, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutput.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutput.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbLine, gbc);
	    pOutput.add(cbLine);
	    gbc = jLayoutGbc(
	      1, 3, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbCppComments, gbc);
	    pOutput.add(cbCppComments);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lCommentBoxWidth, gbc);
	    pOutput.add(lCommentBoxWidth);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfCommentBoxWidth, gbc);
	    pOutput.add(tfCommentBoxWidth);
	  }
	  // pOptions 17
	  pOptions = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pOptions.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      4, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOptions.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pGeneral, gbc);
	    pOptions.add(pGeneral);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pOutput, gbc);
	    pOptions.add(pOutput);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pInput, gbc);
	    pOptions.add(pInput);
	    gbc = jLayoutGbc(
	      3, 3, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pDebug, gbc);
	    pOptions.add(pDebug);
	  }
	  // pa 12
	  pa = new JPanel();
	  {
	    pa.setLayout(new BoxLayout(pa, BoxLayout.PAGE_AXIS));
	    pa.add(Box.createRigidArea(new Dimension(0, b)));
	    pa.add(pOptions);
	    pa.add(Box.createRigidArea(new Dimension(0, b)));
	    pa.add(pButtons);
	    pa.add(Box.createRigidArea(new Dimension(0, b)));
	  }
	  // MAIN 0
	  setTitle(t[26]);
	  setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
	  {
	    Container cp = null;
	    cp = getContentPane();
	    GridBagLayout gbl = new GridBagLayout();
	    cp.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 2, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pa, gbc);
	    cp.add(pa);
	  }
	  jLayoutResetSizes();
	  jLayoutGetSize(bCancel);
	  jLayoutGetSize(bDefaults);
	  jLayoutGetSize(bOK);
	  jLayoutGetSize(bReload);
	  jLayoutSetSize(bCancel);
	  jLayoutSetSize(bDefaults);
	  jLayoutSetSize(bOK);
	  jLayoutSetSize(bReload);
	  bCancel.addActionListener(this);
	  bDefaults.addActionListener(this);
	  bOK.addActionListener(this);
	  bReload.addActionListener(this);
	  cbDebug.addItemListener(this);
	  cbDebugIDE.addItemListener(this);
	  cbMake.addItemListener(this);
	  addWindowListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.setup.end
// jlayout.cleanup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bCancel.removeActionListener(this);
	  bDefaults.removeActionListener(this);
	  bOK.removeActionListener(this);
	  bReload.removeActionListener(this);
	  cbDebug.removeItemListener(this);
	  cbDebugIDE.removeItemListener(this);
	  cbMake.removeItemListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.cleanup.end

    /**
     * Constructor.
     * @param p         Parent frame.
     * @param my_t      Texts to use in the GUI.
     * @param my_tc     Tracecc controller.
     * @param my_dkt    Application controller.
     */
    public TraceccOptions(
            JFrame p,String[] my_t, TraceccController my_tc, DkTool my_dkt
            )
    {
        super(p);
        t = my_t; dkt = my_dkt; tc = my_tc;
        ideTypes = new String[4];
        ideTypes[0] = t[68];
        ideTypes[1] = t[69];
        ideTypes[2] = t[70];
        ideTypes[3] = t[71];
        jLayoutSetup();
        cbIdeType.setSelectedIndex(0);
    }

    /**
     * Cleanup when the application exits.
     */
    protected void cleanup() {
        jLayoutCleanup();
    }

    /**
     * Load data from dialog to tracecc controller.
     */
    protected void putData() {
        boolean[] b = {
            false,  false,
            false,  false,
            false,  false,
            false,  false,
            false,  false,
            false,  false,
            false,
        };
        int[] i = {
            0,  0,
        };
        tc.getData(b, i, null);
        b[0] = cbMake.isSelected();
        b[1] = cbLine.isSelected();
        b[2] = cbCppComments.isSelected();
        b[3] = cbDebug.isSelected();
        b[4] = cbDebugStdout.isSelected();
        b[5] = cbDebugIDE.isSelected();
        b[6] = cbDebugTime.isSelected();
        b[7] = cbDebugTrace.isSelected();
        b[8] = cbC.isSelected();
        b[9] = cbCpp.isSelected();
        b[10] = cbM.isSelected();
        b[11] = cbJtr.isSelected();
        b[12] = cbJl.isSelected();
        i[0] = cbIdeType.getSelectedIndex();
        try {
            int v = Integer.parseInt(tfCommentBoxWidth.getText());
            i[1] = v;
        } catch(Exception e) { i[1] = 75; }
        tc.putData(b, i, null);
    }

    /**
     * Apply corrections to checkboxes and combo boxes.
     * Must be called from the AWT-thread.
     */
    protected void applyCorrections() {
        boolean can_run = false;
        synchronized(this) {
            if(!in_correction) {
                in_correction = true;
                can_run = true;
            }
        }
        if(can_run) {
            if(cbDebug.isSelected()) {
                cbDebugStdout.setEnabled(true);
                cbDebugIDE.setEnabled(true);
                cbDebugTime.setEnabled(true);
                cbDebugTrace.setEnabled(true);
                cbIdeType.setEnabled(cbDebugIDE.isSelected());
            } else {
                cbDebugStdout.setEnabled(false);
                cbDebugIDE.setEnabled(false);
                cbDebugTime.setEnabled(false);
                cbDebugTrace.setEnabled(false);
                cbIdeType.setEnabled(false);
            }
            synchronized(this) {
                in_correction = false;
            }
        }
    }

    /**
     * Load data from tracecc controller to dialog.
     */
    protected void getData() {
        boolean can_run = false;
        boolean[] b = {
            false,  false,
            false,  false,
            false,  false,
            false,  false,
            false,  false,
            false,  false,
            false,
        };
        int[] i = {
            0,  0,
        };
        synchronized(this) {
            if(!in_correction) {
                in_correction = true; can_run = true;
            }
        }
        if(can_run) {
            tc.getData(b, i, null);
            cbMake.setSelected(b[0]);
            cbLine.setSelected(b[1]);
            cbCppComments.setSelected(b[2]);
            cbDebug.setSelected(b[3]);
            cbDebugStdout.setSelected(b[4]);
            cbDebugIDE.setSelected(b[5]);
            cbDebugTime.setSelected(b[6]);
            cbDebugTrace.setSelected(b[7]);
            cbC.setSelected(b[8]);
            cbCpp.setSelected(b[9]);
            cbM.setSelected(b[10]);
            cbJtr.setSelected(b[11]);
            cbJl.setSelected(b[12]);
            if((i[0] >= 0) && (i[0] <= 3)) {
                try {
                    cbIdeType.setSelectedIndex(i[0]);
                } catch(Exception e) {}
            }
            try {
                tfCommentBoxWidth.setText((new Integer(i[1]).toString()));
            } catch(Exception e) {}
            synchronized(this) {
                in_correction = false;
            }
            applyCorrections();
        }
    }



    /**
     * Set reasonable defaults.
     */
    protected void setDefaults() {
        boolean can_run = false;
        synchronized(this) {
            if(!in_correction) {
                in_correction = true;
                can_run = true;
            }
        }
        if(can_run) {
            cbMake.setSelected(false);
            cbLine.setSelected(true);
            cbCppComments.setSelected(false);
            cbDebug.setSelected(false);
            cbDebugStdout.setSelected(false);
            cbDebugIDE.setSelected(false);
            cbDebugTime.setSelected(false);
            cbDebugTrace.setSelected(false);
            cbC.setSelected(true);
            cbCpp.setSelected(true);
            cbM.setSelected(true);
            cbJtr.setSelected(true);
            cbJl.setSelected(true);
            try {
                cbIdeType.setSelectedIndex(0);
            } catch(Exception e) {}
            try {
                tfCommentBoxWidth.setText("75");
            } catch(Exception e) {}
            synchronized(this) {
                in_correction = false;
            }
            applyCorrections();
        }
    }

    /**
     * Indices of texts to check for action commands.
     */
    private static final int[] actionToCheck = {
        27, // Button OK
        28, // Button Cancel
        29, // Button Reset
        30, // Button Defaults
    };


    /**
     * Reaction on button clicks.
     * @param e Action event to process.
     */
    public void actionPerformed(ActionEvent e) {
        String s = e.getActionCommand();
        int action = DkTool.getStringArrayIndex(t, s, actionToCheck);
        switch(action) {
            case 27: {
                setModal(false);
                setVisible(false);
                putData();
            } break;
            case 28: {
                setModal(false);
                setVisible(false);
            } break;
            case 29: {
                getData();
                repaint();
            } break;
            case 30: {
                setDefaults();
                repaint();
            } break;
        }
    }

    /**
     * Reaction on changes to checkboxes.
     * @param e Event to process.
     */
    @Override
    public void itemStateChanged(ItemEvent e) {
        applyCorrections();
    }


    /**
     * Closing the window means the same as pressing the
     * "Cancel" button.
     *
     * @param e
     * The window event triggering the handler.
     */
    public void windowClosing(WindowEvent e)
    {
        setModal(false);
        setVisible(false);
    }

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowActivated(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowClosed(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowDeactivated(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowDeiconified(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowIconified(WindowEvent e) {}

    /**
     * Unused event handler.
     *
     * @param e
     * Window event triggering the handler.
     */
    public void windowOpened(WindowEvent e) {}

}
