/*
Copyright (c) 2010, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/


package traceccgui;

// jlayout.import.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.ImageIcon;
import javax.swing.WindowConstants;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.import.end

import java.awt.Color;
import java.awt.Desktop;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

import java.io.File;
import java.io.InputStreamReader;
import java.io.BufferedReader;

import java.net.URI;
import java.net.URL;

import java.util.ArrayList;
import java.util.TreeMap;
import java.util.Set;

import javax.swing.JFileChooser;
import javax.swing.SwingUtilities;

import dirk_krause.tools.*;

/**
 *
 * @author krause
 */
public class TraceccWindow
        extends DkFrame
        implements ActionListener
{
    class MyDropHandler extends DkDropOneDirectory {
        @Override
        protected boolean processFilename(String fn) {
            boolean back = true;
            if(!getIsRunning()) {
                useNewDirectory(fn);
            }
            return back;
        }
    }

    class ConversionThread implements Runnable {
        public void run() {
            runConversion();
        }
    }

    class ConversionFinished implements Runnable {
        public void run() {
            lStatus1.setText(t[24]);
            lStatus1.setForeground(cGreen);
            lStatus2.setText(t[23]);
            enableComponents(true);
        }
    }

    class LogChanger implements Runnable {
        private Color stc = null;
        private String stt = null;
        private String stm = null;
        private String log = null;
        private boolean is_html = false;
        public LogChanger(Color c, String l1, String l2, String t, boolean f) {
            stc = c; stt = l1; stm = l2; log = t; is_html = f;
        }
        @Override
        public void run() {
            lStatus1.setForeground(stc);
            lStatus1.setText(stt);
            lStatus2.setText(stm);
            pLog.setTextFromAwtThread(log, is_html);
            repaint();
        }
    }

    private MyDropHandler drophandler = null;

// jlayout.variables.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	JButton bDirectory = null;
	JButton bExit = null;
	JButton bOptions = null;
	JButton bRun = null;
	JLabel lDirectory1 = null;
	JLabel lDirectory2 = null;
	JLabel lStatus1 = null;
	JLabel lStatus2 = null;
	JMenu mFile = null;
	JMenuItem mFileDirectory = null;
	JMenuItem mFileExit = null;
	JMenuItem mFileOptions = null;
	JMenuItem mFileRun = null;
	JMenu mHelp = null;
	JMenuItem mHelpDocu = null;
	JMenuItem mHelpVersion = null;
	JMenuItem mHelpWeb = null;
	JMenu mSetup = null;
	JMenuItem mSetupGui = null;
	JMenuBar mb = null;
	DkLogPanel pLog = null;
	JPanel pa = null;
	JToolBar tbButtons = null;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.variables.end

// jlayout.setup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Find an image icon.
	 *
	 * @param n
	 * The name of the image icon file.
	 *
	 * @return
	 * The image icon.
	 */
	protected ImageIcon jLayoutImageIconFromName(String n)
	{
	  ImageIcon back = null;
	  try {
	    back = new ImageIcon(getClass().getResource(n));
	  }
	  catch(NullPointerException e) {
	    back = new ImageIcon(n);
	  }
	  return back;
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bDirectory 83
	  bDirectory = new JButton(jLayoutImageIconFromName(bifn[0]));
	  bDirectory.setActionCommand(t[3]);
	  bDirectory.setToolTipText(t[13]);
	  bDirectory.getAccessibleContext().setAccessibleDescription(
	    t[13]
	  );
	  // bExit 86
	  bExit = new JButton(jLayoutImageIconFromName(bifn[3]));
	  bExit.setActionCommand(t[6]);
	  bExit.setToolTipText(t[16]);
	  bExit.getAccessibleContext().setAccessibleDescription(
	    t[16]
	  );
	  // bOptions 84
	  bOptions = new JButton(jLayoutImageIconFromName(bifn[1]));
	  bOptions.setActionCommand(t[4]);
	  bOptions.setToolTipText(t[14]);
	  bOptions.getAccessibleContext().setAccessibleDescription(
	    t[14]
	  );
	  // bRun 85
	  bRun = new JButton(jLayoutImageIconFromName(bifn[2]));
	  bRun.setActionCommand(t[5]);
	  bRun.setToolTipText(t[15]);
	  bRun.getAccessibleContext().setAccessibleDescription(
	    t[15]
	  );
	  // lDirectory1 122
	  lDirectory1 = new JLabel(t[22]);
	  // lDirectory2 123
	  lDirectory2 = new JLabel(t[25]);
	  // lStatus1 125
	  lStatus1 = new JLabel(t[24]);
	  // lStatus2 126
	  lStatus2 = new JLabel(t[23]);
	  // mFileDirectory 26
	  mFileDirectory = new JMenuItem(t[3]);
	  mFileDirectory.setToolTipText(t[13]);
	  mFileDirectory.getAccessibleContext().setAccessibleDescription(
	    t[13]
	  );
	  // mFileExit 29
	  mFileExit = new JMenuItem(t[6]);
	  mFileExit.setToolTipText(t[16]);
	  mFileExit.getAccessibleContext().setAccessibleDescription(
	    t[16]
	  );
	  // mFileOptions 27
	  mFileOptions = new JMenuItem(t[4]);
	  mFileOptions.setToolTipText(t[14]);
	  mFileOptions.getAccessibleContext().setAccessibleDescription(
	    t[14]
	  );
	  // mFileRun 28
	  mFileRun = new JMenuItem(t[5]);
	  mFileRun.setToolTipText(t[15]);
	  mFileRun.getAccessibleContext().setAccessibleDescription(
	    t[15]
	  );
	  // mHelpDocu 63
	  mHelpDocu = new JMenuItem(t[11]);
	  mHelpDocu.setToolTipText(t[19]);
	  mHelpDocu.getAccessibleContext().setAccessibleDescription(
	    t[19]
	  );
	  // mHelpVersion 62
	  mHelpVersion = new JMenuItem(t[10]);
	  mHelpVersion.setToolTipText(t[18]);
	  mHelpVersion.getAccessibleContext().setAccessibleDescription(
	    t[18]
	  );
	  // mHelpWeb 64
	  mHelpWeb = new JMenuItem(t[12]);
	  mHelpWeb.setToolTipText(t[20]);
	  mHelpWeb.getAccessibleContext().setAccessibleDescription(
	    t[20]
	  );
	  // mSetupGui 53
	  mSetupGui = new JMenuItem(t[8]);
	  mSetupGui.setToolTipText(t[17]);
	  mSetupGui.getAccessibleContext().setAccessibleDescription(
	    t[17]
	  );
	  // pLog 124
	  pLog = new DkLogPanel();
	  // pa 15
	  pa = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pa.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      5, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      5, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.01, 0.01
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lDirectory1, gbc);
	    pa.add(lDirectory1);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lDirectory2, gbc);
	    pa.add(lDirectory2);
	    gbc = jLayoutGbc(
	      1, 3, 4, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      1, 1
	    );
	    gbl.setConstraints(pLog, gbc);
	    pa.add(pLog);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lStatus1, gbc);
	    pa.add(lStatus1);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lStatus2, gbc);
	    pa.add(lStatus2);
	  }
	  // tbButtons 14
	  tbButtons = new JToolBar();
	  {
	    tbButtons.add(bDirectory);
	    tbButtons.add(bOptions);
	    tbButtons.add(bRun);
	    tbButtons.add(bExit);
	  }
	  // mFile 19
	  mFile = new JMenu();
	  mFile.setText(t[2]);
	  {
	    mFile.add(mFileDirectory);
	    mFile.add(mFileOptions);
	    mFile.add(mFileRun);
	    mFile.add(mFileExit);
	  }
	  // mHelp 22
	  mHelp = new JMenu();
	  mHelp.setText(t[9]);
	  {
	    mHelp.add(mHelpVersion);
	    mHelp.add(mHelpDocu);
	    mHelp.add(mHelpWeb);
	  }
	  // mSetup 20
	  mSetup = new JMenu();
	  mSetup.setText(t[7]);
	  {
	    mSetup.add(mSetupGui);
	  }
	  // mb 11
	  mb = new JMenuBar();
	  {
	    mb.add(mFile);
	    mb.add(mSetup);
	    mb.add(Box.createHorizontalGlue());
	    mb.add(mHelp);
	  }
	  // MAIN 0
	  setTitle(t[0]);
	  setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	  {
	    setJMenuBar(mb);
	    Container cp = null;
	    cp = getContentPane();
	    cp.add(tbButtons, BorderLayout.PAGE_START);
	    cp.add(pa, BorderLayout.CENTER);
	  }
	  bDirectory.setTransferHandler(drophandler);
	  bDirectory.addActionListener(this);
	  bExit.setTransferHandler(drophandler);
	  bExit.addActionListener(this);
	  bOptions.setTransferHandler(drophandler);
	  bOptions.addActionListener(this);
	  bRun.setTransferHandler(drophandler);
	  bRun.addActionListener(this);
	  lDirectory1.setTransferHandler(drophandler);
	  lDirectory2.setTransferHandler(drophandler);
	  lStatus1.setTransferHandler(drophandler);
	  lStatus2.setTransferHandler(drophandler);
	  mFileDirectory.addActionListener(this);
	  mFileExit.addActionListener(this);
	  mFileOptions.addActionListener(this);
	  mFileRun.addActionListener(this);
	  mHelpDocu.addActionListener(this);
	  mHelpVersion.addActionListener(this);
	  mHelpWeb.addActionListener(this);
	  mSetupGui.addActionListener(this);
	  pLog.setTransferHandler(drophandler);
	  pa.setTransferHandler(drophandler);
	  tbButtons.setTransferHandler(drophandler);
	  mb.setTransferHandler(drophandler);
	  setTransferHandler(drophandler);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.setup.end

// jlayout.cleanup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bDirectory.removeActionListener(this);
	  bExit.removeActionListener(this);
	  bOptions.removeActionListener(this);
	  bRun.removeActionListener(this);
	  mFileDirectory.removeActionListener(this);
	  mFileExit.removeActionListener(this);
	  mFileOptions.removeActionListener(this);
	  mFileRun.removeActionListener(this);
	  mHelpDocu.removeActionListener(this);
	  mHelpVersion.removeActionListener(this);
	  mHelpWeb.removeActionListener(this);
	  mSetupGui.removeActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.cleanup.end

    /** Strings and texts used in the GUI. */
    protected String[] t = null;

    /** Application controller. */
    // protected DkTool dkt = null;

    /** Application GUI controller. */
    // protected DkGuiTool dkgt = null;

    /** Tracecc controller. */
    protected TraceccController tc = null;

    /** Border (space between GUI components). */
    protected int b = 5;

    /** Flag to indicate whether or not there is a conversion thread. */
    protected boolean isRunning = false;

    /** GUI setup dialog. */
    protected DkGuiDialog guid = null;

    /** Status line color red. */
    protected final Color cRed = new Color(127, 0, 0);

    /** Status line color green. */
    protected final Color cGreen = new Color(0, 127, 0);

    /** Options dialog box. */
    protected TraceccOptions to = null;

    /** Help text for local help. */
    protected String helpText = null;

    /** File names for button icons. */
    public static final String[] bifn = {
        "ChooseDirectory.png",
        "Options.png",
        "Run.png",
        "Exit.png",
    };

    public static final String copyright =
        "<html>\n"
        + "<body>\n"
        + "<p>Tracecc GUI 1.3.0</p>"
        + "<p>Copyright (c) 2009, Dirk Krause<br>\n"
        + "All rights reserved.\n"
        + "</p>\n"
        + "<p>\n"
        + "Redistribution and use in source and binary forms,\n"
        + "with or without modification, are permitted provided\n"
        + "that the following conditions are met:\n"
        + "</p>\n"
        + "<ul>\n"
        + "<li>Redistributions of source code must retain the above\n"
        + "copyright notice, this list of conditions and the\n"
        + "following disclaimer.</li>\n"
        + "<li>Redistributions in binary form must reproduce the above \n"
        + "copyright notice, this list of conditions and the following\n"
        + "disclaimer in the documentation and/or other materials\n"
        + "provided with the distribution.</li>\n"
        + "<li>Neither the name of the Dirk Krause nor the names of\n"
        + "contributors may be used to endorse or promote\n"
        + "products derived from this software without specific\n"
        + "prior written permission.</li>\n"
        + "</ul>\n"
        + "<p>\n"
        + "THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND\n"
        + "CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,\n"
        + "INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\n"
        + "MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n"
        + "DISCLAIMED.\n"
        + "IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE\n"
        + "LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,\n"
        + "EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n"
        + "LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n"
        + "LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\n"
        + "HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\n"
        + "CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE\n"
        + "OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
        + "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH\n"
        + "DAMAGE.\n"
        + "</p>\n"
        + "</body>\n"
        + "</html>\n";


    public static final String[] kw = {
        "<html><body>",         //  0
        "</body></html>",       //  1
        "<p>",                  //  2
        "</p>",                 //  3
        " (",                   //  4
        ")",                    //  5
        "/",                    //  6
        "<br>",                 //  7
        "&nbsp;",               //  8
        "<b>",                  //  9
        "</b>",                 // 10
        "",                     // 11
    };

    /**
     * Check whether there is a conversion thread running.
     * @return Flag: Conversion running.
     */
    public boolean getIsRunning() {
        boolean back = false;
        synchronized(this) {
            back = isRunning;
        }
        return back;
    }

    /**
     * Mark flag running.
     * @param v New flag value.
     */
    protected void setIsRunning(boolean v) {
        synchronized(this) {
            isRunning = v;
        }
    }

    /**
     * Check whether or not we can start a run.
     * @return  Flag to indicate: Can run.
     */
    protected boolean canRun() {
        boolean back = false;
        synchronized(this) {
            if(!isRunning) {
                isRunning = true;
                back = true;
            }
        }
        return back;
    }

    /**
     * Constructor.
     * @param n Texts used in the GUI.
     * @param d Application controller.
     * @param g GUI controller.
     * @param c Tracecc controller.
     */
    public TraceccWindow(String[] n, DkTool d, DkGuiTool g, TraceccController c)
    {
        super(n[0], d, g);
        t = n; tc = c;
        b = g.getComponentBorder();
        String s = c.getStr(0);
        drophandler = new MyDropHandler();
        jLayoutSetup();
        lStatus1.setForeground(cGreen);
        if(s != null) {
            lDirectory2.setText(s);
        }
        pack();
    }

    /**
     * Enable/disable GUI components.
     * From AWT thread only.
     * @param v Flag: Enable or disable.
     */
    protected void changeGuiComponents(boolean v) {
        bDirectory.setEnabled(v);
        bOptions.setEnabled(v);
        bRun.setEnabled(v);
        bExit.setEnabled(v);
        mFileDirectory.setEnabled(v);
        mFileOptions.setEnabled(v);
        mFileRun.setEnabled(v);
        mFileExit.setEnabled(v);
    }

    /**
     * New directory was choosen.
     * From AWT-thread only.
     * @param d New directory.
     */
    protected void useNewDirectory(String d) {
        tc.setStr(0, d);
        tc.saveSettings();
        lDirectory2.setText(d);
        lDirectory2.repaint();
    }

    protected void setupDirectory() {
        String d = tc.getStr(0);
        JFileChooser c;
        if(d != null) { c = new JFileChooser(d); }
        else { c = new JFileChooser(); }
        c.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int result = c.showOpenDialog(this);
        if(result == JFileChooser.APPROVE_OPTION) {
            d = c.getSelectedFile().getAbsolutePath();
            useNewDirectory(d);
        }

    }

    protected void showOptionsDialog() {
        TraceccOptions todb = null;
        synchronized(this) {
            todb = to;
        }
        if(todb == null) {
            todb = new TraceccOptions(this, t, tc, dkt);
            todb.pack();
            DkTool.chooseModalPosition(scw, sch, this, todb);
            synchronized(this) {
                to = todb;
            }
        }
        if(todb != null) {
            todb.getData();
            todb.setModal(true);
            todb.setVisible(true);
        }
    }

    protected void openLocalHelp() {
        String ht;
        synchronized(this) {
            ht = helpText;
        }
        if(ht == null) {
            ht = dkt.getLocalizedString(this, "index.html");
	    if(ht != null) {
                synchronized(this) {
                    helpText = ht;
                }
            }
        }
        if(ht != null) {
            showMessageDialog(t[72], ht, true);
        } else {
            msgError(t[73], t[74], false);
        }
    }

    protected void openWebHelp() {
        try {
            Desktop.getDesktop().browse(new URI(t[75]));
        } catch(Exception e) {}
    }

    protected boolean canStartRun() {
        boolean back = false;
        synchronized(this) {
            if(!isRunning) {
                back = true; isRunning = true;
            }
        }
        return back;
    }

    protected void enableComponents(boolean f) {
        mFileDirectory.setEnabled(f);
        mFileOptions.setEnabled(f);
        mFileRun.setEnabled(f);
        mFileExit.setEnabled(f);
        bDirectory.setEnabled(f);
        bOptions.setEnabled(f);
        bExit.setEnabled(f);
        bRun.setEnabled(f);
    }

    protected String createEntireLogString(StringBuilder s) {
        String back = null;
        StringBuilder sb = new StringBuilder();
        sb.append(kw[0]);
        sb.append(new String(s));
        sb.append(kw[1]);
        back = new String(sb);
        return back;
    }


    private String removeTrailingWhitespaces(String s) {
        String back = null;
	int l = s.length();
	int i;
	int spp = -1;
	char c;
	for(i = 0; i < l; i++) {
	    c = s.charAt(i);
	    switch(c) {
	         case ' ': case '\t': case '\n': case '\r': {
		     if(spp == -1) {
		         spp = i;
		     }
		 } break;
		 default: {
		     spp = -1;
		 } break;
	    }
	}
	if(spp == -1) {
	    back = s;
	} else {
	    back = s.substring(0, spp);
	}
	return back;
    }

    /**
     * Do conversion.
     * This function runs in a separated (background) thread.
     */
    protected void runConversion() {
        // TODO: Run the conversion.
        int ci = 1;
        StringBuilder sb = new StringBuilder();
        TraceccCommandSet tcs = tc.createListOfCommands();
        TreeMap<String,String[]> tm = tcs.getCommands();
        String dirname = tcs.getDirectory();
        Set<String> ks = tm.keySet();
        Object[] oa = ks.toArray();
        String l = null;
        String fn = null;
        for(Object objfilename: oa) {
            fn = (String)objfilename;
            l = createEntireLogString(sb);
            SwingUtilities.invokeLater(
                new LogChanger(cRed, t[76], fn, l, true)
            );
            sb.append(kw[2]);       // <p>
            sb.append(dkt.encodeToHtml(fn));
            sb.append(kw[4]);
            sb.append((new Integer(ci)).toString());
            sb.append(kw[6]);
            sb.append((new Integer(oa.length)).toString());
            sb.append(kw[5]);
            sb.append(kw[7]);
            try {
                String[] cc = null;
                try {
                    cc = tm.get((String)objfilename);
                } catch(Exception e) { cc = null; }
                if(cc != null) {
                    if(cc.length > 0) {
                        StringBuilder cmdsb = new StringBuilder();
                        for(int x = 0; x < cc.length; x++) {
                            if(x > 0) { sb.append(kw[8]); }
                            sb.append(dkt.encodeToHtml(cc[x]));
                        }
                        sb.append(kw[7]);
                        InputStreamReader isr = null;
                        BufferedReader in = null;
                        try {
                            ProcessBuilder pb = new ProcessBuilder(cc);
                            if(tcs.getDirectory() != null) {
                                pb.directory(new File(tcs.getDirectory()));
                            }
                            Process p = pb.start();
                            isr = new InputStreamReader(
                                p.getInputStream(), "UTF-8"
                            );
                            in = new BufferedReader(isr);
                            for(String il; (il = in.readLine()) != null; ) {
                                boolean bold_flag = true;
                                String nl = removeTrailingWhitespaces(il);
                                if(nl.startsWith("#")) {
                                    bold_flag = false;
                                }
                                if(bold_flag) {
                                    sb.append(kw[9]);
                                }
                                sb.append(dkt.encodeToHtml(nl));
                                if(bold_flag) {
                                    sb.append(kw[10]);
                                }
                                sb.append(kw[7]);
                            }
                            if(in != null) {
                                try { in.close(); } catch(Exception e) {}
                            }
                            if(isr != null) {
                                try { isr.close(); } catch(Exception e) {}
                            }
                            in = null; isr = null;
                            isr = new InputStreamReader(
                                p.getErrorStream(), "UTF-8"
                            );
                            in = new BufferedReader(isr);
                            for(String il; (il = in.readLine()) != null; ) {
                            }
                            if(in != null) {
                                try { in.close(); } catch(Exception e) {}
                            }
                            if(isr != null) {
                                try { isr.close(); } catch(Exception e) {}
                            }
                            in = null; isr = null;
                            try { p.waitFor(); } catch(Exception e) {
                                sb.append(kw[9]);
                                sb.append(dkt.encodeToHtml(t[77]));
                                sb.append(kw[10]);
                                sb.append(kw[7]);
                            }
                        } catch(Exception e) {
                            sb.append(kw[9]);
                            sb.append(dkt.encodeToHtml(t[77]));
                            sb.append(kw[10]);
                            sb.append(kw[7]);
                        }
                    }
                }
            } catch(Exception e) {}
            sb.append(kw[3]);       // </p>
            ci++;
            l = createEntireLogString(sb);
            SwingUtilities.invokeLater(
                new LogChanger(cRed, t[76], fn, l, true)
            );
        }
        synchronized(this) {
            isRunning = false;
        }
        l = createEntireLogString(sb);
        SwingUtilities.invokeLater(
            new LogChanger(cRed, t[76], (fn == null) ? kw[11] : fn, l, true)
        );
        SwingUtilities.invokeLater(new ConversionFinished());
    }

    /**
     * Start the background thread for conversion.
     */
    protected void startRun() {
        try {
            enableComponents(false);
            Thread thr = new Thread(new ConversionThread());
            thr.start();
        } catch(Exception e) {
            synchronized(this) {
                isRunning = false;
            }
            enableComponents(true);
        }
    }


    private final int[] actionsToCheck = {
        3, 4, 5, 6, 8, 10, 11, 12
    };

    @Override
    public void actionPerformed(ActionEvent e) {
        // TODO: Reaction on button clicks
        String ac = e.getActionCommand();
        int a = DkTool.getStringArrayIndex(t, ac, false);
        switch(a) {
            case 3: {   // File Directory
                if(!getIsRunning()) {
                    setupDirectory();
                }
            } break;
            case 4: {   // File Options
                if(!getIsRunning()) {
                    showOptionsDialog();
                }
            } break;
            case 5: {   // File Run
                if(canStartRun()) {
                    startRun();
                }
            } break;
            case 6: {   // File Exit
                if(!getIsRunning()) {
                    processWindowEvent(
                        new WindowEvent(this, WindowEvent.WINDOW_CLOSING)
                    );
                }
            } break;
            case 8: {   // Setup GUI
                showGuiDialog();
            } break;
            case 10: {  // Version
                showMessageDialog(t[21], copyright, true);
            } break;
            case 11: {  // Docu
                openLocalHelp();
            } break;
            case 12: {  // Web
                openWebHelp();
            } break;
        }
    }

    @Override
    public void cleanup(boolean isLast) {
        if(isLast) {
            tc.saveSettings();
        }
        jLayoutCleanup();
    }
}
