#! /bin/sh
echo Running prep-dist.sh
STCOPT="--/log/stderr/level=error --/log/stdout/level=none"
stc $STCOPT -p dkapp.str    share
stc $STCOPT -p dkappd.str   share
stc $STCOPT -p dkappe.str   share
stc $STCOPT -p stc.str      share/stc
stc $STCOPT -p trana.str    share/trana
stc $STCOPT -p tracecc.str  share/tracecc
stc $STCOPT -p tracecca.str share/tracecc

JAVA=`which java`
JAVADIR=`echo $JAVA | sed -e 's/\/bin\/java//g' | sed -e 's/\/jre$//g'`
JNLP=`find $JAVADIR -name 'javaws.jar'`
echo JAVA=$JAVA
echo JAVADIR=$JAVADIR
echo JNLP=$JNLP

cd Java
rm -fr doc/dklibsj
rm -fr doc/wdklibsj
rm -fr doc/traceccgui
mkdir -p doc/dklibsj
mkdir -p doc/wdklibsj
mkdir -p doc/traceccgui

rm -fr dklibsj
rm -fr wdklibsj
rm -fr jar
mkdir -p dklibsj
mkdir -p wdklibsj
mkdir -p jar

cd src

for i in dirk_krause/tools/*.java
do
  echo javac -cp . -d ../dklibsj $i
  javac -cp . -d ../dklibsj $i
done

for i in traceccgui/*.java
do
  echo javac -cp . -d ../jar $i
  javac -cp . -d ../jar $i
done

for i in dirk_krause/wstools/*.java
do
  echo javac -cp .:$JNLP -d ../wdklibsj $i
  javac -cp .:$JNLP -d ../wdklibsj $i
done


echo javadoc -d ../doc/dklibsj -classpath . -doctitle 'dklibsj - Libraries for Java (Dirk Krause)' dirk_krause/tools/*.java
javadoc -d ../doc/dklibsj -classpath . -doctitle 'dklibsj - Libraries for Java (Dirk Krause)' dirk_krause/tools/*.java
echo javadoc -d ../doc/wdklibsj -classpath .:$JNLP -doctitle 'wdklibsj - Libraries for Java webstart (Dirk Krause)' dirk_krause/wstools/*.java
javadoc -d ../doc/wdklibsj -classpath .:$JNLP -doctitle 'wdklibsj - Libraries for Java webstart (Dirk Krause)' dirk_krause/wstools/*.java
echo javadoc -d ../doc/traceccgui -classpath . -doctitle 'Tracecc GUI' traceccgui/*.java
javadoc -d ../doc/traceccgui -classpath . -doctitle 'Tracecc GUI' traceccgui/*.java

cd ..

(cd res; tar cf - .) | (cd jar; tar xf -)
(cd loc; tar cf - .) | (cd jar; tar xf -)
(cd jar.in; tar cf - .) | (cd jar; tar xf -)
cp splash/splash.png jar

cd jar
cp ChooseDirectory.png traceccgui
cp Options.png traceccgui
cp Run.png traceccgui
cp Exit.png traceccgui
jar -cvfm ../../tracegui.jar manifest.in *
cd ..

cd dklibsj
jar -cvf ../../dklibsj.jar dirk_krause
cd ..

cd wdklibsj
jar -cvf ../../wdklibsj.jar dirk_krause
cd ..

cd ..

