package uselessform;

import javax.swing.SwingUtilities;

import dirk_krause.tools.*;

class GuiCreator implements Runnable {
    private String dir = null;
    private String[] def_t = null;

    public GuiCreator(String s, String[] t) {
        dir = s; def_t = t;
    }

    public void run() {
        DkTool dkt = new DkTool(def_t[0], def_t[1], dir);
        DkGuiTool dkg = new DkGuiTool(dkt);
        String[] loc_t = dkt.getLocalizedArray(this, "useless.txt");
        String[] t = def_t;
        if(loc_t != null) { if(loc_t.length >= def_t.length) t = loc_t; }
        UselessWindow w = new UselessWindow(dkt, dkg, t);
        w.pack();
        w.choosePosition();
        w.setVisible(true);
    }
}

/**
 *
 * @author krause
 */
public class UselessFormMain {
    /** Texts used in the GUI. */
    public static final String[] def_t = {
        /*   0 */ "UselessForm",            // Application name
        /*   1 */ "NonsensApplications",    // Application group name
        /*   2 */ "Surname:",               // GUI elements
        /*   3 */ "Name:",
        /*   4 */ "Opinion:",
        /*   5 */ "Very good",
        /*   6 */ "Useless",
        /*   7 */ "Waste of time",
        /*   8 */ "Print",
        /*   9 */ "Exit",
        /*  10 */ "Please enter your surname here.",    // Tool-tip texts
        /*  11 */ "Please enter your name here.",
        /*  12 */ "Please specify your opinion about this program here.",
        /*  13 */ "Print certificate about the filled form.",
        /*  14 */ "Exit this application.",
        /*  15 */ "Error",  // Error message
        /*  16 */ "Please fill all the text fields.",
    };

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String dir = null;
        if(args.length > 0) { dir = args[0]; }
        SwingUtilities.invokeLater(new GuiCreator(dir, def_t));
    }

}
